=== navit/fib-1.1/CMakeLists.txt ===
supportlib_add_library(fib fib.c)
