=== navit/fonts/CMakeLists.txt ===
add_custom_target( fonts ALL DEPENDS ${NAVIT_FONTS}
	COMMAND ${CMAKE_COMMAND}
	-D GLOB_EXP="${CMAKE_CURRENT_SOURCE_DIR}/*.ttf" #${NAVIT_FONTS}"
	-D DST=${CMAKE_CURRENT_BINARY_DIR}
	-P ${PROJECT_SOURCE_DIR}/cmake/copy_files.cmake
	)

FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.ttf")
install(
	FILES ${files}
	DESTINATION ${SHARE_DIR}/fonts
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
