=== debian/changelog ===
navit (0.5.6+dfsg.1-5) unstable; urgency=medium

  * Support CMake 4 (closes: #1113314)

 -- Gilles Filippini <pini@debian.org>  Mon, 13 Oct 2025 20:25:59 +0200

navit (0.5.6+dfsg.1-4) unstable; urgency=medium

  [ Pino Toscano ]
  * Remove Debian menu

 -- Gilles Filippini <pini@debian.org>  Thu, 02 Jan 2025 09:31:14 +0100

navit (0.5.6+dfsg.1-3) unstable; urgency=medium

  * Backport upstream fix for GCC-14 support (closes: #1075306)

 -- Gilles Filippini <pini@debian.org>  Thu, 08 Aug 2024 19:07:05 +0200

navit (0.5.6+dfsg.1-2) unstable; urgency=medium

  [ Gilles Filippini ]
  * Switch back to rsvg-convert as svg2png converter
  * navit-data: install whole directory /usr/share/navit to have the
    default layouts and the textures sub-directory

  [ Jelmer Vernooĳ ]
  * Use secure URI in Homepage field
  * Set upstream metadata fields: Bug-Database, Repository
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright)
  * Fix day-of-week for changelog entry 0.0.4+svn1229-2

 -- Gilles Filippini <pini@debian.org>  Sun, 22 Jan 2023 19:42:22 +0100

navit (0.5.6+dfsg.1-1) unstable; urgency=medium

  * New patch fix-1002204.patch to fix a 'no format argument' printf like
    error (closes: #1002204)
  * Upload to unstable

 -- Gilles Filippini <pini@debian.org>  Tue, 21 Dec 2021 21:39:51 +0100

navit (0.5.6+dfsg.1-1~exp1) experimental; urgency=medium

  [ Joseph Herlant ]
  * Remove myself from Uploaders

  [ Gilles Filippini ]
  * New upstream release
  * Remove patches (fixed upstream):
    - inkscape-1.0.patch
    - multiple-definition-of-map_information_attrs.patch
    - gps.h-api10
  * d/copyright: add missing information

 -- Gilles Filippini <pini@debian.org>  Sat, 27 Mar 2021 08:37:49 +0100
